#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include "borrower.h"

#define DEBUG 0 

typedef struct node node;

struct node {
    borrower *theborrower;
    node *next;
};

node *borrowers = NULL; /* pointer to beginning of members list */

void add_borr(char *line) {

    int i=0; /* Loop Index */
    int j=0; /* Token Index */
    int k=1; /* borrower Field Index */

    borrower *newborrower = malloc(sizeof(borrower));
    node *newnode = malloc(sizeof(node));
    node *borrowerbackup = malloc(sizeof(node)); /* backup the beginning */

    char *token = NULL;
    int finished = 0;
	
    while((finished != 1)) {
        if((line[i] == ':') || (line[i] == '\0')) {

            switch (k) {
                case 1:
                    newborrower->id = token;
                    break;
                case 2:
                    newborrower->name = token;
                    break;
                case 3:
                    newborrower->age = token;
                    break;
            }
            k++;
            j=0;
		
            token = NULL;

            if(line[i] == '\0') {
                finished = 1;
            }
        } else {
            if(token == NULL) {
                token = malloc(2);
                token[j] = line[i];
                token[j+1] = '\0';
            } else {
                token = realloc(token,j+2);
                token[j] = line[i];
                token[j+1] = '\0';
            }
            j++;
        }
        i++;
    }
	
    /* start putting the borrowers into nodes and linking them together */
    newnode->theborrower = newborrower;
    if(borrowers == NULL) {
        borrowers = newnode;
    } else {
        borrowerbackup = borrowers;
        while(borrowers->next != NULL) {
            borrowers = borrowers->next;
        }
        borrowers->next = newnode;
        borrowers = borrowerbackup;
    }
}

void print_borrs() {
    node *thisnode;
    int finished = 0;
    thisnode = borrowers;
    printf("[MEMBERS LIST]\n\n");
    while(!finished) {
        printf("%s - %s, age %s\n",thisnode->theborrower->id,thisnode->theborrower->name,thisnode->theborrower->age);
        if(thisnode->next != NULL) {
            thisnode = thisnode->next;
        } else {
            finished = 1;
        }
    }
}

borrower *find_borr(int id) {
    node *thisnode = borrowers;
    borrower *thisborrower = NULL;
    int finished = 0;
    int currid;

    while(!finished) {
        currid = atoi(thisnode->theborrower->id);
        if(currid == id) {
            finished = 1;
            thisborrower = thisnode->theborrower;
        } else {
            if(thisnode->next != NULL) {
                thisnode = thisnode->next;
            } else {
                finished = 1;
                thisborrower = NULL;
            }
        }
    }
    return thisborrower;
}

